#!/usr/bin/env python3

import datetime 
import crontab
import subprocess

def create_cron_entries(dates, command):
    cron_entries = []
    
    for date in dates:
        date = datetime.datetime.strptime(date, "%Y-%m-%d").date()

        # Cron for 2 days before
        two_days_before = date - datetime.timedelta(days=2)
        if two_days_before.weekday() < 5:
            cron = crontab.CronTab(f'{two_days_before.minute} {two_days_before.hour} {two_days_before.day} {two_days_before.month} {two_days_before.weekday()')
            print(cron)
            cron_entries.append(str(cron))

        # Cron for the date
        if date.weekday() < 5:  
            cron = crontab.CronTab(f'{date.minute} {date.hour} {date.day} {date.month} {date.weekday()')
            print(cron) 
            cron_entries.append(str(cron))

    crontab = '\n'.join(cron_entries) 
    print()
    print(crontab)
    
    # Write crontab  
    p = subprocess.Popen('crontab', stdin=subprocess.PIPE)
    p.communicate(input=crontab.encode())

dates = ["2023-03-15", "2023-04-01", "2023-04-12"]  
command = "/path/to/script.py"

create_cron_entries(dates, command)
